% rsspecan MATLAB example

% version 2.0 14.04.2016
% - corrected for rsspecan VXI plug&play driver 3.6.1 and newer

% version 1.0
% - Initial version

function varargout = fsw_gui(varargin)
% FSW_GUI MATLAB code for fsw_gui.fig
%      FSW_GUI, by itself, creates a new FSW_GUI or raises the existing
%      singleton*.
%
%      H = FSW_GUI returns the handle to a new FSW_GUI or the handle to
%      the existing singleton*.
%
%      FSW_GUI('CALLBACK',hObject,eventData,handles,...) calls the local
%      function named CALLBACK in FSW_GUI.M with the given input arguments.
%
%      FSW_GUI('Property','Value',...) creates a new FSW_GUI or raises the
%      existing singleton*.  Starting from the left, property value pairs are
%      applied to the GUI before fsw_gui_OpeningFcn gets called.  An
%      unrecognized property name or invalid value makes property application
%      stop.  All inputs are passed to fsw_gui_OpeningFcn via varargin.
%
%      *See GUI Options on GUIDE's Tools menu.  Choose "GUI allows only one
%      instance to run (singleton)".
%      
%      FSW GUI is for signal & spectrum analyzer FSW. The instrument settings
%      frequency start, stop and center, frequency span, sweep mode (single
%      or continuous) and sweep points can be set. The trace can be
%      plotted.
%      This example uses custom built MATLAB mdd driver which will be provided with
%      rsspecan VXI plug&play driver

% See also: GUIDE, GUIDATA, GUIHANDLES

% Last Modified by GUIDE v2.5 14-Apr-2016 12:22:50

% Begin initialization code - DO NOT EDIT
gui_Singleton = 1;
gui_State = struct('gui_Name',       mfilename, ...
                   'gui_Singleton',  gui_Singleton, ...
                   'gui_OpeningFcn', @fsw_gui_OpeningFcn, ...
                   'gui_OutputFcn',  @fsw_gui_OutputFcn, ...
                   'gui_LayoutFcn',  [] , ...
                   'gui_Callback',   []);
if nargin && ischar(varargin{1})
    gui_State.gui_Callback = str2func(varargin{1});
end

if nargout
    [varargout{1:nargout}] = gui_mainfcn(gui_State, varargin{:});
else
    gui_mainfcn(gui_State, varargin{:});
end
% End initialization code - DO NOT EDIT


% --- Executes just before fsw_gui is made visible.
function fsw_gui_OpeningFcn(hObject, eventdata, handles, varargin)
% This function has no output args, see OutputFcn.
% hObject    handle to figure
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)
% varargin   command line arguments to fsw_gui (see VARARGIN)
    
% Data for plotting traces and showing image
    handles.SPAtrace          = hObject;
    handles.SPAtrace          = 1;              % Selects trace 1 for plotting
    handles.SPAtrace2         = hObject;
    handles.SPAtrace2         = 2;              % Selects trace 2 for plotting
    handles.SPArepcapWinTrace1 = hObject;
    handles.SPArepcapWinTrace1 = 'Win0,TR1';    % repcap Window 0, trace 1
    handles.SPArepcapWinTrace2 = hObject;
    handles.SPArepcapWinTrace2 = 'Win0,TR2';    % repcap Window 0, trace 2
    handles.SPAtimeoutMs      = hObject;        % Pass the maximum length of time in which to allow the read waveform operation to complete (in [ms])
    handles.SPAtimeoutMs      = 5000;           % Timeout 5000 ms
    handles.SPAarrayLen       = hObject;        % Includes the number of sweep points: 101 to 32001         
    handles.SPAarrayActualLen = hObject;
    handles.SPAarrayActualLen = -1;
    handles.SPAcoorsX = hObject;                % X coordinates for plotting the trace
    handles.SPAcoorsY = hObject;                % Y coordinates for plotting the trace
    handles.numOfSweeps = hObject;              % For number of sweeps when measuring                      
    handles.SPAwindow = hObject;
    handles.SPAwindow = 0;                      % Actual window
    
% Choose default command line output for fsw_gui
handles.output = hObject;

% Update handles structure
guidata(hObject, handles);

% UIWAIT makes fsw_gui wait for user response (see UIRESUME)
 %uiwait(handles.figure1);


% --- Outputs from this function are returned to the command line.
function varargout = fsw_gui_OutputFcn(hObject, eventdata, handles) 
% varargout  cell array for returning output args (see VARARGOUT);
% hObject    handle to figure
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)

% Get default command line output from handles structure
varargout{1} = handles.output;


function Adress_Callback(hObject, eventdata, handles)
% hObject    handle to Adress (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)

% Hints: get(hObject,'String') returns contents of Adress as text
%        str2double(get(hObject,'String')) returns contents of Adress as a double

% --- Executes during object creation, after setting all properties.

% After connect button has been pressed, connection to adress is valid
set(handles.connect,'Enable', 'on');


function Adress_CreateFcn(hObject, eventdata, handles)
% hObject    handle to Adress (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    empty - handles not created until after all CreateFcns called

% Hint: edit controls usually have a white background on Windows.
%       See ISPC and COMPUTER.
if ispc && isequal(get(hObject,'BackgroundColor'), get(0,'defaultUicontrolBackgroundColor'))
    set(hObject,'BackgroundColor','white');
end


% --- Executes on selection change in initSettings.
function initSettings_Callback(hObject, eventdata, handles)
% hObject    handle to initSettings (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)

% Hints: contents = cellstr(get(hObject,'String')) returns initSettings contents as cell array
%        contents{get(hObject,'Value')} returns selected item from initSettings

% Choose how to connect the instrument: Via TCPIP, GPIB or USB
value = get(handles.initSettings,'value');
if value == 1
    set(handles.Adress,'string', 'Select initial setting');
elseif value == 2
    set(handles.Adress,'string','TCPIP::put_IPaddress_here::INSTR');
    % For Example:
    set(handles.Adress,'string','TCPIP::127.0.0.1::INSTR');
elseif value == 3
    set(handles.Adress,'string','GPIB::put_your_address_here::INSTR');
elseif value == 4
    set(handles.Adress,'string','GPIB::put_first_address_here::put_second_address_here::INSTR');
elseif value == 5
    set(handles.Adress,'string','USB::put_vendor_ID::put_product_ID::put_serial_number::INSTR');    
    % For Example:
    set(handles.Adress,'string','USB::0x0AAD::0x00C8::101794::INSTR');              % vendor ID for R&S = 0x0AAD; product ID for FSW26 = 0x00C8; serial number = 101794
end

if value == 1
    set(handles.connect,'Enable','off');                                            % If no setting is chosen, connect button cannot be pressed
else
    set(handles.connect,'Enable','on');                                             % If setting is chosen, connect button can be pressed
end



% --- Executes during object creation, after setting all properties.
function initSettings_CreateFcn(hObject, eventdata, handles)
% hObject    handle to initSettings (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    empty - handles not created until after all CreateFcns called

% Hint: popupmenu controls usually have a white background on Windows.
%       See ISPC and COMPUTER.
if ispc && isequal(get(hObject,'BackgroundColor'), get(0,'defaultUicontrolBackgroundColor'))
    set(hObject,'BackgroundColor','white');
end


% --- Executes on button press in connect.
function connect_Callback(hObject, eventdata, handles)
% hObject    handle to connect (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)

% Press the connect button to connect the instrument and get the default
% values of the instrument.
guidata(hObject,handles);
set(handles.connect,'String','Creating Matlab Object...');
drawnow();
stringTOconnect = get(handles.Adress,'string');
deviceObj = icdevice('rsspecan.mdd', stringTOconnect);

handles.deviceObj = deviceObj;
guidata(hObject,handles);
set(handles.connect,'String','Connecting to the Instrument...');
connect(deviceObj)

set(handles.connect,'BackgroundColor','Green');
set(handles.connect,'String','Connected');
set(handles.connect,'Enable','off');
set(handles.disconnect,'Enable','on');

set(handles.startMeasurement,'Enable','on');
set(handles.readValues,'Enable','on');

devicereset(deviceObj);         % Resets instrument
invoke (deviceObj, 'ConfigureDisplayUpdate', 1)     % Display Update stays on in remote control

% Get setting of instrument
freqcenter = invoke(deviceObj, 'GetProperty', 'ATTR_FREQUENCY_CENTER');     % Get default value center frequency
set(handles.freqcenter,'string',freqcenter);
freqstart = invoke(deviceObj, 'GetProperty', 'ATTR_FREQUENCY_START');       % Get default value start frequency
set(handles.freqstart,'string',freqstart);
freqstop = invoke(deviceObj, 'GetProperty', 'ATTR_FREQUENCY_STOP');         % Get default value stop frequency
set(handles.freqstop,'string',freqstop);
freqspan = invoke(deviceObj, 'GetProperty', 'ATTR_FREQUENCY_SPAN');         % Get default value span frequency
set(handles.freqspan,'string',freqspan);
SweepPoints = invoke(deviceObj, 'GetProperty', 'ATTR_SWEEP_POINTS');        % Get default value sweep points
set(handles.sweepPoints,'string',SweepPoints);
numOfsweeps = invoke(deviceObj, 'GetProperty', 'Number of Sweeps'); % Get default value number of sweeps
set(handles.sweepCount,'string',num2str(numOfsweeps));
invoke(deviceObj, 'ConfigureAcquisition', 0, 0, 1);                 % Set to single sweep

% For Example, set default values of instrument to specific values:
devicereset(deviceObj);                                                     % Resets instrument
freqcenter = 500E+6;                                                        % Set center frequency to 500 MHz
invoke(deviceObj, 'SetProperty', 'ATTR_FREQUENCY_CENTER', freqcenter);      
set(handles.freqcenter,'string',num2str(freqcenter));
freqspan = 200E+6;                                                          % Set span frequency to 200 MHz
invoke(deviceObj, 'SetProperty', 'ATTR_FREQUENCY_SPAN', freqspan);
set(handles.freqspan,'string',num2str(freqspan));
freqstart = invoke(deviceObj, 'GetProperty', 'ATTR_FREQUENCY_START');       % Get value of start frequency depending on center and span frequency
set(handles.freqstart,'string',num2str(freqstart));
freqstop = invoke(deviceObj, 'GetProperty', 'ATTR_FREQUENCY_STOP');         % Get value stop frequency depending on center and span frequency
set(handles.freqstop,'string',num2str(freqstop));
SweepPoints = 512;
invoke(deviceObj, 'SetProperty', 'ATTR_SWEEP_POINTS', SweepPoints);         % Set sweep points to 512
set(handles.sweepPoints,'string',num2str(SweepPoints));
numOfsweeps = 10;                                                           % Set number of sweeps for measurement to 10
invoke(deviceObj, 'SetProperty', 'Number of Sweeps', numOfsweeps); 
set(handles.sweepCount,'string',num2str(numOfsweeps));
invoke(deviceObj, 'ConfigureAcquisition', 0, 0, 1);                         % Set to single sweep
invoke(handles.deviceObj, 'SetProperty', 'Trace Type', 3, handles.SPArepcapWinTrace1); % Set trace 1 to mode "Max Hold"
set(handles.trace1Mode,'value',2);
invoke(handles.deviceObj, 'SetProperty', 'Trace Type', 2, handles.SPArepcapWinTrace2); % Set trace 2 to mode "Average"
set(handles.trace2Mode,'value',4);

function freqcenter_Callback(hObject, eventdata, handles)
% hObject    handle to freqcenter (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)

% Hints: get(hObject,'String') returns contents of freqcenter as text
%        str2double(get(hObject,'String')) returns contents of freqcenter as a double
% Set frequency center and update other values (frequency span,...) for GUI
freqcenter_str = get(handles.freqcenter,'string');
invoke(handles.deviceObj, 'SetProperty', 'ATTR_FREQUENCY_CENTER', str2num(freqcenter_str));
freqstart = invoke(handles.deviceObj, 'GetProperty', 'ATTR_FREQUENCY_START');
set(handles.freqstart,'string',freqstart);
freqstop = invoke(handles.deviceObj, 'GetProperty', 'ATTR_FREQUENCY_STOP');
set(handles.freqstop,'string',freqstop);
freqspan = invoke(handles.deviceObj, 'GetProperty', 'ATTR_FREQUENCY_SPAN');
set(handles.freqspan,'string',freqspan);


% --- Executes during object creation, after setting all properties.
function freqcenter_CreateFcn(hObject, eventdata, handles)
% hObject    handle to freqcenter (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    empty - handles not created until after all CreateFcns called

% Hint: edit controls usually have a white background on Windows.
%       See ISPC and COMPUTER.
if ispc && isequal(get(hObject,'BackgroundColor'), get(0,'defaultUicontrolBackgroundColor'))
    set(hObject,'BackgroundColor','white');
end


function freqspan_Callback(hObject, eventdata, handles)
% hObject    handle to freqspan (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)

% Hints: get(hObject,'String') returns contents of freqspan as text
%        str2double(get(hObject,'String')) returns contents of freqspan as a double
% Set frequency span and update other values (frequency center,...) for GUI
freqspan_str = get(handles.freqspan,'string');
invoke(handles.deviceObj, 'SetProperty', 'RSSPECAN_Attr_FrequencY_SpaN', str2num(freqspan_str));
freqstart = invoke(handles.deviceObj, 'GetProperty', 'ATTR_FREQUENCY_START');
set(handles.freqstart,'string',freqstart);
freqstop = invoke(handles.deviceObj, 'GetProperty', 'ATTR_FREQUENCY_STOP');
set(handles.freqstop,'string',freqstop);
freqcenter = invoke(handles.deviceObj, 'GetProperty', 'ATTR_FREQUENCY_CENTER');
set(handles.freqcenter,'string',freqcenter);


% --- Executes during object creation, after setting all properties.
function freqspan_CreateFcn(hObject, eventdata, handles)
% hObject    handle to freqspan (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    empty - handles not created until after all CreateFcns called

% Hint: edit controls usually have a white background on Windows.
%       See ISPC and COMPUTER.
if ispc && isequal(get(hObject,'BackgroundColor'), get(0,'defaultUicontrolBackgroundColor'))
    set(hObject,'BackgroundColor','white');
end


function freqstart_Callback(hObject, eventdata, handles)
% hObject    handle to freqstart (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)

% Hints: get(hObject,'String') returns contents of freqstart as text
%        str2double(get(hObject,'String')) returns contents of freqstart as a double
% Set frequency start and update other values (frequency center,...) for GUI
freqstart_str = get(handles.freqstart,'string');
invoke(handles.deviceObj, 'SetProperty', 'RSSPECAN_ATTR_FREQUENCY_START', str2num(freqstart_str));
freqcenter = invoke(handles.deviceObj, 'GetProperty', 'ATTR_FREQUENCY_CENTER');
set(handles.freqcenter,'string',freqcenter);
freqspan = invoke(handles.deviceObj, 'GetProperty', 'ATTR_FREQUENCY_SPAN');
set(handles.freqspan,'string',freqspan);
freqstop = invoke(handles.deviceObj, 'GetProperty', 'ATTR_FREQUENCY_STOP');
set(handles.freqstop,'string',freqstop);


% --- Executes during object creation, after setting all properties.
function freqstart_CreateFcn(hObject, eventdata, handles)
% hObject    handle to freqstart (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    empty - handles not created until after all CreateFcns called

% Hint: edit controls usually have a white background on Windows.
%       See ISPC and COMPUTER.
if ispc && isequal(get(hObject,'BackgroundColor'), get(0,'defaultUicontrolBackgroundColor'))
    set(hObject,'BackgroundColor','white');
end


function freqstop_Callback(hObject, eventdata, handles)
% hObject    handle to freqstop (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)

% Hints: get(hObject,'String') returns contents of freqstop as text
%        str2double(get(hObject,'String')) returns contents of freqstop as a double
% Set frequency stop and update other values (frequency center,...) for GUI 
freqstop_str = get(handles.freqstop,'string');
invoke(handles.deviceObj, 'SetProperty', 'RSSPECAN_ATTR_FREQUENCY_STOP', str2num(freqstop_str));
freqcenter = invoke(handles.deviceObj, 'GetProperty', 'ATTR_FREQUENCY_CENTER');
set(handles.freqcenter,'string',freqcenter);
freqspan = invoke(handles.deviceObj, 'GetProperty', 'ATTR_FREQUENCY_SPAN');
set(handles.freqspan,'string',freqspan);
freqstart = invoke(handles.deviceObj, 'GetProperty', 'ATTR_FREQUENCY_START');
set(handles.freqstart,'string',freqstart);


% --- Executes during object creation, after setting all properties.
function freqstop_CreateFcn(hObject, eventdata, handles)
% hObject    handle to freqstop (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    empty - handles not created until after all CreateFcns called

% Hint: edit controls usually have a white background on Windows.
%       See ISPC and COMPUTER.
if ispc && isequal(get(hObject,'BackgroundColor'), get(0,'defaultUicontrolBackgroundColor'))
    set(hObject,'BackgroundColor','white');
end


% --- Executes on selection change in trace1Mode.
function trace1Mode_Callback(hObject, eventdata, handles)
% hObject    handle to trace1Mode (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)

% Hints: contents = cellstr(get(hObject,'String')) returns trace1Mode contents as cell array
%        contents{get(hObject,'Value')} returns selected item from trace1Mode
% Set the mode of trace 1 to plot: "Max Hold", "Min Hold", "Average"
mode = get(handles.trace1Mode,'value');
if mode == 1
    set(handles.startMeasurement,'Enable','off');
elseif mode == 2
    invoke(handles.deviceObj, 'SetProperty', 'Trace Type', 3, handles.SPArepcapWinTrace1);      % 3 = "Max Hold"
    set(handles.startMeasurement,'Enable','on');
elseif mode == 3
    invoke(handles.deviceObj, 'SetProperty', 'Trace Type', 4, handles.SPArepcapWinTrace1);      % 4 = "Min Hold"
    set(handles.startMeasurement,'Enable','on');
elseif mode == 4
    invoke(handles.deviceObj, 'SetProperty', 'Trace Type', 2, handles.SPArepcapWinTrace1);      % 2 = "Average"
    set(handles.startMeasurement,'Enable','on');
end 


% --- Executes during object creation, after setting all properties.
function trace1Mode_CreateFcn(hObject, eventdata, handles)
% hObject    handle to trace1Mode (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    empty - handles not created until after all CreateFcns called

% Hint: popupmenu controls usually have a white background on Windows.
%       See ISPC and COMPUTER.
if ispc && isequal(get(hObject,'BackgroundColor'), get(0,'defaultUicontrolBackgroundColor'))
    set(hObject,'BackgroundColor','white');
end


% --- Executes on selection change in trace2Mode.
function trace2Mode_Callback(hObject, eventdata, handles)
% hObject    handle to trace2Mode (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)

% Hints: contents = cellstr(get(hObject,'String')) returns trace2Mode contents as cell array
%        contents{get(hObject,'Value')} returns selected item from trace2Mode
% Set the mode of trace 2 to plot: "Max Hold", "Min Hold", "Average"
mode = get(handles.trace2Mode,'value');
if mode == 1
    set(handles.startMeasurement,'Enable','off');
elseif mode == 2
    invoke(handles.deviceObj, 'SetProperty', 'Trace Type', 3, handles.SPArepcapWinTrace2);      % 3 = "Max Hold"
    set(handles.startMeasurement,'Enable','on');
elseif mode == 3
    invoke(handles.deviceObj, 'SetProperty', 'Trace Type', 4, handles.SPArepcapWinTrace2);      % 4 = "Min Hold"
    set(handles.startMeasurement,'Enable','on');
elseif mode == 4
    invoke(handles.deviceObj, 'SetProperty', 'Trace Type', 2, handles.SPArepcapWinTrace2);      % 2 = "Average"
    set(handles.startMeasurement,'Enable','on');
end 

% --- Executes during object creation, after setting all properties.
function trace2Mode_CreateFcn(hObject, eventdata, handles)
% hObject    handle to trace2Mode (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    empty - handles not created until after all CreateFcns called

% Hint: popupmenu controls usually have a white background on Windows.
%       See ISPC and COMPUTER.
if ispc && isequal(get(hObject,'BackgroundColor'), get(0,'defaultUicontrolBackgroundColor'))
    set(hObject,'BackgroundColor','white');
end

% --- Executes on button press in startMeasurement.
function startMeasurement_Callback(hObject, eventdata, handles)
% hObject    handle to startMeasurement (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)

    invoke(handles.deviceObj, 'WriteInstrData', '*CLS');
    handles.SPAarrayLen = invoke(handles.deviceObj, 'GetProperty', 'RSSPECAN_ATTR_SWEEP_POINTS');
    handles.SPAcoorsX = zeros(handles.SPAarrayLen, 1);
    handles.SPAcoorsY = zeros(handles.SPAarrayLen, 1);
    SPAtrace1Type = invoke(handles.deviceObj, 'GetProperty', 'Trace Type',handles.SPArepcapWinTrace1); % Get the mode of trace 1 - for the example the mode is "Max Hold"
    SPAtrace2Type = invoke(handles.deviceObj, 'GetProperty', 'Trace Type',handles.SPArepcapWinTrace2); % Get the mode of trace 2 - for the example the mode is "Average"
    
    
    handles.numOfSweeps = str2num(get(handles.sweepCount,'string'));
    invoke(handles.deviceObj, 'SetProperty', 'Number of Sweeps', handles.numOfSweeps);
    
    [handles.SPAarrayActualLen, handles.SPAcoorsX] = invoke(handles.deviceObj, 'FetchXTrace', handles.SPAwindow, handles.SPAtrace, handles.SPAarrayLen, handles.SPAcoorsX);
   
    % Set trace 1 set to Minhold
    set(handles.deviceObj, 'RepCapIdentifier', handles.SPArepcapWinTrace1);
    invoke(handles.deviceObj, 'SetProperty', 'Trace Type', SPAtrace1Type);
    %or with one command:
    %invoke(deviceObj, 'SetProperty', 'Trace Type', SPAtrace1Type, SPArepcapWinTrace1);
    
    % Set trace 2 to Maxhold
    set(handles.deviceObj, 'RepCapIdentifier', handles.SPArepcapWinTrace2);
    invoke(handles.deviceObj, 'SetProperty', 'Trace Type', SPAtrace2Type);
    %or with one command:
    %invoke(handles.deviceObj, 'SetProperty', 'Trace Type', handles.SPAtrace2Type, handles.SPArepcapWinTrace2);
    
    % Initiate the single sweep, wait for it to finish
    SPAtimeoutMs = 15000;
    invoke(handles.deviceObj, 'Initiate', handles.SPAwindow, SPAtimeoutMs);
    
    % Read trace data 1, no sweeping
    [handles.SPAarrayActualLen, handles.SPAcoorsY] = invoke(handles.deviceObj, 'FetchYTrace', handles.SPAwindow, handles.SPAtrace, handles.SPAarrayLen, handles.SPAcoorsY);
    
    % plot 1st curve
    axes(handles.plotTraces);                       % As there are two windows to plot in the GUI, specifiy in which window the traces should be plotted
    plot(handles.SPAcoorsX, handles.SPAcoorsY);
    hold all;
    
    % Read trace data 2, no sweeping
    [handles.SPAarrayActualLen, handles.SPAcoorsY] = invoke(handles.deviceObj, 'FetchYTrace', handles.SPAwindow, handles.SPAtrace2, handles.SPAarrayLen, handles.SPAcoorsY);
    
    % Plot 2nd curve to same graph
    axes(handles.plotTraces);                       % As there are two windows to plot in the GUI, specifiy in which window the traces should be plotted
    plot(handles.SPAcoorsX, handles.SPAcoorsY);
    legend('Trace 1','Trace 2');
    hold off;

function sweepPoints_Callback(hObject, eventdata, handles)
% hObject    handle to sweepPoints (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)

% Hints: get(hObject,'String') returns contents of sweepPoints as text
%        str2double(get(hObject,'String')) returns contents of sweepPoints as a double
% Set number of sweep points 
sweepPoints_str = get(handles.sweepPoints,'string');
invoke(handles.deviceObj, 'SetProperty', 'Sweep Points', str2num(sweepPoints_str));

    
% --- Executes during object creation, after setting all properties.
function sweepPoints_CreateFcn(hObject, eventdata, handles)
% hObject    handle to sweepPoints (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    empty - handles not created until after all CreateFcns called

% Hint: edit controls usually have a white background on Windows.
%       See ISPC and COMPUTER.
if ispc && isequal(get(hObject,'BackgroundColor'), get(0,'defaultUicontrolBackgroundColor'))
    set(hObject,'BackgroundColor','white');
end


function sweepCount_Callback(hObject, eventdata, handles)
% hObject    handle to sweepCount (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)

% Hints: get(hObject,'String') returns contents of sweepCount as text
%        str2double(get(hObject,'String')) returns contents of sweepCount as a double
set(handles.startMeasurement,'Enable', 'on');
handles.numOfSweeps = str2num(get(handles.sweepCount,'string'));
invoke(handles.deviceObj, 'SetProperty', 'Number of Sweeps', handles.numOfSweeps);


% --- Executes during object creation, after setting all properties.
function sweepCount_CreateFcn(hObject, eventdata, handles)
% hObject    handle to sweepCount (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    empty - handles not created until after all CreateFcns called

% Hint: edit controls usually have a white background on Windows.
%       See ISPC and COMPUTER.
if ispc && isequal(get(hObject,'BackgroundColor'), get(0,'defaultUicontrolBackgroundColor'))
    set(hObject,'BackgroundColor','white');
end


% --- Executes on button press in readValues.
function readValues_Callback(hObject, eventdata, handles)
% hObject    handle to readValues (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)

%% Hardcopy and file transfer to PC
    % Take screenshot of the analyzer screen, store it to the instrument
    % path "c:\matlab_screenshot.png" and copy it to the PC to
    % path "c:\matlab_screenshot.png"
    ActualReadLen = -1;
    SPAhcopyDevice = 1;
    SPAhcopyItems = 0; %screenshot of all items
    SPAinstrumentFilePath = 'c:\INSTR_matlab_screenshot.png';
    SPApcFilePath = 'c:\PC_matlab_screenshot.png';
       
    % clear status
    invoke(handles.deviceObj, 'WriteInstrData', '*CLS');
    
    % Set up the instrument file path
    invoke(handles.deviceObj, 'HardcopySetFileName', SPAinstrumentFilePath);
        
    % Add a comment string to the SPA screenshot
    invoke (handles.deviceObj, 'HardcopyComment', 'FSW Measurement with Matlab.');
    
    % Take the screenshot of the SPA screen now
    invoke(handles.deviceObj, 'HardcopyPrint', SPAhcopyDevice, SPAhcopyItems);
          
    % Transfer the file content to the PC
    invoke(handles.deviceObj, 'ReadToFileFromInstrument', SPAinstrumentFilePath, SPApcFilePath);
    
    % Show Hardcopy path in GUI
    set(handles.pathHardcopy,'string', ['Screenshot path on PC: ' SPApcFilePath]);
    
    % Showing the screenshot
    axes(handles.showImage);
    [imdata] = imread(SPApcFilePath);
    imagesc(imdata);
    
    % --- Executes on button press in disconnect.
function disconnect_Callback(hObject, eventdata, handles)
% hObject    handle to disconnect (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)
% Disconnect button disconnects instrument
disconnect(handles.deviceObj);
delete(handles.deviceObj);
set(handles.connect,'String','Connect Instrument');
set(handles.connect,'Enable','on');
set(handles.disconnect,'Enable','off');
set(handles.startMeasurement,'Enable','off');
set(handles.readValues,'Enable','off');
set(handles.connect,'BackgroundColor', [0.94 0.94 0.94]);

% --- Executes when user attempts to close figure1.
function figure1_CloseRequestFcn(hObject, eventdata, handles)
% hObject    handle to figure1 (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)
try
    delete(hObject);
    disconnect(handles.deviceObj);
    delete(handles.deviceObj);
    % Hint: delete(hObject) closes the figure
    
catch

end
